//+------------------------------------------------------------------+
//|                                                 ja fibonacci.mq4 |
//|                                                           .....h |
//|                                                    hayseedfx.com |
//+------------------------------------------------------------------+
#property copyright ".....h"
#property link      "hayseedfx.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  clrDeepSkyBlue

 extern int    shift         =         1;
 extern int    corner        =         3;
 extern int    textsize      =        12;
 extern string font          = "Verdana";   
 extern color  textcolor     =   Magenta;    
 extern bool   comments      =     false;
 extern bool   display       =      true;
 extern int    arrow         =       251;
 extern int    totalbars     =        10;
 extern string UniqueID      = "JaWindow";
        double percent;
        datetime currentprice;
        datetime currenttime;
        int bar;
double ja[];        
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
      SetIndexBuffer(0,ja);
      IndicatorShortName(UniqueID);
//---- 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   DeleteAllObjects();
   DeleteAllObjects();
   DeleteAllObjects();
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   for(int i=limit; i>=0; i--)
   {
      if (High[i]-Low[i]!=0)
            ja[i] = ((Close[i]-Low[i])/(High[i]-Low[i]))*100;
      else  ja[i] = 0;
   }  
  //----
     double high    = iHigh(Symbol(),0,shift); 
     double low     = iLow(Symbol(),0,shift); 
     double close   = iClose(Symbol(),0,shift);

            percent = ((close-low)/(high-low))*100;

   if(display)
     {
     Display("%",30,30,percent);     
     }


   if(comments)
     {
     Comment(DoubleToStr(percent,0)+" %");
     }
     
      if(bar != Bars)
        {
         currentprice = Open[1];
         currenttime  = Time[1];
         
         Draw(Bars,all(1),Time[1],Open[1],Close[1]);
         bar = Bars;
        }

     for(i=1;i<totalbars;i++)
        {
         currentprice = Open[i];
         currenttime  = Time[i];
         
         Draw(Bars-i,all(i),Time[i],Open[i],Close[i]);
        }
        
//----
   return(0);
  }
//+------------------------------------------------------------------+
void Draw(int bars, double per, datetime t, double p, double c)
    {

   string name = UniqueID+bars+"  "+DoubleToStr(per,0)+"%   "+DoubleToStr(c,Digits);
   ObjectCreate(name,OBJ_ARROW, 0, t,p);
   ObjectSet(name, OBJPROP_WIDTH, 1);   
   ObjectSet(name,OBJPROP_ARROWCODE,arrow); 
   ObjectSet(name,OBJPROP_COLOR,textcolor);
   }

  
  
double all(int tshift)
     {
     double hi    = iHigh(Symbol(),0,tshift); 
     double lo    = iLow(Symbol(),0,tshift); 
     double cl    = iClose(Symbol(),0,tshift);
     double pt    = ((cl-lo)/(hi-lo))*100;
     
     return(pt);
     }


void Display(string name, int x, int y,string text)
   {
   int window = WindowFind(UniqueID);
   name = UniqueID+name;
   ObjectDelete(name);
   ObjectCreate(name, OBJ_LABEL, window, 0, 0);
   ObjectSet(name, OBJPROP_CORNER, corner);
   ObjectSet(name, OBJPROP_XDISTANCE, x);
   ObjectSet(name, OBJPROP_YDISTANCE, y);
   ObjectSetText(name, DoubleToStr(percent,0)+"  %",textsize,font,textcolor);
   
   ObjectSet(name, OBJPROP_BACK, FALSE);
   }  
   
 void DeleteAllObjects()
   {
   int objs = ObjectsTotal();
   string name;
   for(int cnt=ObjectsTotal()-1;cnt>=0;cnt--)
   {
      name=ObjectName(cnt);
      if(StringFind(name,"%",0) > -1) ObjectDelete(name);
 
   }
   }       